function Level(difficulty)
{
    this.canvas = document.getElementById('canvas');
	this.player = null;
	this.horizontalSpawners = [];
	this.verticalSpawners = [];
	this.wallSize = 40 - (difficulty * 5);
	this.completed = false;
	this.playerDead = false;
	this.levelNumber = difficulty;
	
	for (var x = 0; x < this.canvas.width / this.wallSize; x++)
	{
		this.verticalSpawners.push(new Spawner((x * this.wallSize) + this.wallSize, -this.wallSize, true, this.wallSize));
	}
	
	for (var y = 0; y < this.canvas.height / this.wallSize; y++)
	{
		this.horizontalSpawners.push(new Spawner(this.canvas.width + this.wallSize, (y * this.wallSize) + this.wallSize, false, this.wallSize));
	}
	
	this.player = new Player(0, 100, this);
	
	this.update = function()
	{
		if (!this.completed && !this.playerDead)
		{
			for (h in this.horizontalSpawners)
			{
				this.horizontalSpawners[h].update();
			}
			
			for (v in this.verticalSpawners)
			{
				this.verticalSpawners[v].update();
			}
			
			this.player.update();
		}
		else
		{
		
		}
	}
	
	this.draw = function(ctx)
	{
		if (!this.completed && !this.playerDead)
		{
			for (h in this.horizontalSpawners)
			{
				this.horizontalSpawners[h].draw(ctx);
			}
			
			for (v in this.verticalSpawners)
			{
				this.verticalSpawners[v].draw(ctx);
			}
			
			this.player.draw(ctx);
		}
		else
		{
		
		}
	}
}