var FPS = 30;
var canvas = null;
var ctx = null;
var level = null;
var currentDifficulty = 0;
var playerDeaths = 0;
window.onload = init;

addEventListener("dblclick", function (e)
{
	if (level == null)
	{
		level = new Level(0);
	}
	else if  (level.completed)
	{
		if (currentDifficulty == 7)
		{
			currentDifficulty = 0;
		}
		else
		{
			currentDifficulty = level.levelNumber + 1;
		}
		level = new Level(currentDifficulty);
	}
	else if (level.playerDead)
	{
		playerDeaths++;
		level = null;
	}
	
}, false);

function init()
{
    canvas = document.getElementById('canvas');
    ctx = canvas.getContext('2d');
	
	setInterval(gameLoop, 1000/FPS);
}

function gameLoop()
{
	update();
	
    // Clear the screen
    ctx.clearRect(0, 0, canvas.width, canvas.height);
    ctx.fillStyle='#7178B5';
    ctx.fillRect(0, 0, canvas.width, canvas.height);
	
	draw();
}

function update()
{
	if (level != null)
	{
		level.update();
	}
}

function draw()
{
	if (level != null)
	{
		if (level.completed)
		{
			if (currentDifficulty == 7)
			{
				ctx.fillStyle = "#D7DEFF";
				ctx.font="40px Verdana";
				ctx.textAlign="center";
				ctx.fillText("You completed all the levels!",canvas.width/2, canvas.height / 2 - 20);
				ctx.fillText("Double-click to play again.",canvas.width/2, canvas.height / 2 + 20);
			}
			else
			{
				ctx.fillStyle = "#D7DEFF";
				ctx.font="40px Verdana";
				ctx.textAlign="center";
				ctx.fillText("Level " + (currentDifficulty + 1) + " complete.",canvas.width/2, canvas.height / 2 - 20);
				
				if (currentDifficulty == 6)
				{
					ctx.fillText("Double-click to proceed to final level.",canvas.width/2, canvas.height / 2 + 20);
				}
				else
				{
					ctx.fillText("Double-click to proceed to level " + (currentDifficulty + 2) + ".",canvas.width/2, canvas.height / 2 + 20);
				}
			}
		}
		else if (level.playerDead)
		{
			ctx.fillStyle = "#D7DEFF";
			ctx.font="30px Verdana";
			ctx.textAlign="center";
			ctx.fillText("You died.",canvas.width/2, canvas.height / 2 - 15);
			ctx.fillText("Double-click to return to start screen.",canvas.width/2, canvas.height / 2 + 15);
		}
		else
		{
			level.draw(ctx);
		}
	}
	else // Title screen
	{
		ctx.fillStyle = "#FFFFFF";
		ctx.font="15px Verdana";
		ctx.textAlign="center";
		strs =	[];
		strs.push("You are a white square.");
		strs.push("You will start on the far left side of the screen.");
		strs.push("Your objective is to reach the far right side of the screen.");
		strs.push("If the moving black blocks hit you, you lose health.");
		strs.push("The faster they move, the more health they will take away.");
		strs.push("If your health reaches 0, you lose.");
		strs.push("WSAD to move.");
		
		i = 0;
		for (; i < strs.length; i++)
		{
			ctx.fillText(strs[i],canvas.width/2, (i+1) * 20);
		}
		
		i += 15;
		ctx.fillStyle = "#D7DEFF";
		ctx.font="40px Verdana";
		ctx.fillText("Double-click to begin.",canvas.width/2, canvas.height - 40);
		
		if (playerDeaths > 0)
		{
			ctx.font="20px Verdana";
			ctx.fillStyle = "#AA4444";
			ctx.fillText("HINT: If you aren't moving when a block hits you, you won't get hurt.",canvas.width/2, canvas.height / 2 - 10);
		}
	}
}