function Spawner(xIn, yIn, isVertical, wallSizeIn)
{
    this.canvas = document.getElementById('canvas');
	this.x = xIn;
	this.y = yIn;
	this.wallSize = wallSizeIn;
	
	this.maxSpeed = 13;
	this.speed = 0;
	this.vertical = isVertical;
	
	this.currentBlock = null;
	
	this.getNewBlock = function()
	{
		if (this.vertical)
		{
			this.direction = new Point(0,1);
			blockHeight = Math.floor(Math.random() * 10) * this.wallSize;
			this.currentBlock = new Block(this.x, this.y - blockHeight, this.wallSize, blockHeight);
		}
		else
		{
			this.direction = new Point(-1,0);
			blockWidth = Math.floor(Math.random() * 10) * this.wallSize;
			this.currentBlock = new Block(this.x, this.y, blockWidth, this.wallSize);
		}
		
		this.speed = Math.floor(Math.random() * this.maxSpeed) + 2;
		this.currentBlock.damage = 1 + (15 - (15 - this.speed));
	}
	
	this.getNewBlock();
	
	this.update = function()
	{
		if (this.currentBlock.x < -this.wallSize - this.currentBlock.rect.w || this.currentBlock.y > this.canvas.height)
		{
			this.getNewBlock();
		}
		
		this.currentBlock.x += this.direction.x * this.speed;
		this.currentBlock.y += this.direction.y * this.speed;
		this.currentBlock.rect.x = this.currentBlock.x;
		this.currentBlock.rect.y = this.currentBlock.y;
	}
	
	this.draw = function(ctx)
	{
		if (this.currentBlock != null)
		{
			this.currentBlock.draw(ctx);
		}
	}
	
}